//<c>   Copyright 1993-1999 by Gerry J. Danen; all rights reserved.

//<t>   NetWare Volume Usage

//      Compiled with Microsoft C 8.00. Requires DANEN library to recompile.
//      Source released into the Public Domain.

#include"gd_tools.h"
#include"gd_nw.h"
#include"nit.h"
#include"ntt.h"


#define pgVERS_ "V3.00"
#define pgTITL_ "NetWare Volume Usage"
#define pgCOPR_ "1993"


void    instructions( void )
{
    printf( "\nUse /V for verbose mode, or /G for graphics mode\n\n" );
    exit( 1 );
}


void    main( int argc, char *argv[] )
{
    int         x, x1, bar_used, bar_purg, bar_free ;
    WORD        ccode, volNumber, serverConnID ;
    NWVOL_USAGE v ;
    UCHAR       a[3], serverName[48], s_tBytes[15], s_fBytes[15], s_pBytes[15], s_aBytes[15] ;
    ULONG       v_tBytes, v_fBytes, v_pBytes, v_aBytes, p_fBytes, p_pBytes, p_aBytes ;
    BOOL        verbose = FALSE, graphics = FALSE ;

    tt_init( SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );
    logon(0);

    if ( ! nw_installed_NetWare() )
    {
        printf( "NetWare not available\n" );
        exit( 1 );
    }

    argc -= 1 ;
    LOOP( x, 1, argc, 1 )                       // get params
    {
        st_cpy( a, argv[x], 3 );
        if ( st_eq(a, "/v") )
            verbose = TRUE ;
        if ( st_eq(a, "/g") )
            graphics = TRUE ;
        if ( st_eq(a, "/h") || st_eq(a, "/?") )
            instructions();
    }

    GetFileServerName( (WORD) 0, serverName );
    GetConnectionID( serverName, &serverConnID );

    if ( graphics )
    {
        printf( "Server %s\n", serverName );
        LOOP( x, 0, 31, 1 )
        {
            volNumber = x ;
            ccode = GetVolUsage( serverConnID, volNumber, &v );
            if ( ccode )
            {
                printf( "Error %03d(%02X) in GetVolUsage(%lu,%lu)\n", ccode, ccode, (ULONG) serverConnID, (ULONG) volNumber );
            }
            else
            {
                if ( ! st_eq(v.volName," ") )
                {
                    v_aBytes = ((v.purgableBlocks+v.freeBlocks) * v.blockSize) / SZ_kBYTE ;
                    Format_UINT32( v_aBytes, s_aBytes );
                    printf( "%-55s %15s Kb free\n", v.volName, s_aBytes );

                    p_pBytes = (v.purgableBlocks * 1000L / v.totalBlocks) + 5 ;
                    p_pBytes /= 10L ;
                    p_aBytes = ((v.totalBlocks-(v.purgableBlocks+v.freeBlocks)) * 1000L / v.totalBlocks) + 5 ;
                    p_aBytes /= 10L ;

                    // show total bytes used, and purgable bytes

                    bar_used = p_aBytes ? (int) p_aBytes * 79 / 100 : 0;
                    bar_purg = p_pBytes ? (int) p_pBytes * 79 / 100 : 0;
                    bar_free = 79 - (bar_used + bar_purg) ;
                    if ( bar_used )  for( x1=0; x1 < bar_used; x1++ )  printf( "%s", "\xDB" );
                    if ( bar_purg )  for( x1=0; x1 < bar_purg; x1++ )  printf( "%s", "\xB0" );
                    if ( bar_free )  for( x1=0; x1 < bar_free; x1++ )  printf( "%s", "\xFE" );
                    printf( "\n" );
                }
            }
        }
    }
    else
    {
        LOOP( x, 0, 31, 1 )
        {
            volNumber = x ;
            ccode = GetVolUsage( serverConnID, volNumber, &v );
            if ( ccode )
            {
                printf( "Error %03d(%02X) in GetVolUsage(%lu,%lu)\n", ccode, ccode, (ULONG) serverConnID, (ULONG) volNumber );
            }
            else
            {
                if ( ! st_eq(v.volName," ") )
                {
                    v_tBytes = v.blockSize * v.totalBlocks ;
                    v_fBytes = v.blockSize * v.freeBlocks ;
                    v_pBytes = v.blockSize * v.purgableBlocks ;
                    v_aBytes = v.blockSize * (v.purgableBlocks+v.freeBlocks);
                    Format_UINT32( v_tBytes, s_tBytes );
                    Format_UINT32( v_fBytes, s_fBytes );
                    Format_UINT32( v_pBytes, s_pBytes );
                    Format_UINT32( v_aBytes, s_aBytes );

                    p_fBytes = (v.freeBlocks * 1000L / v.totalBlocks) + 5 ;
                    p_pBytes = (v.purgableBlocks * 1000L / v.totalBlocks) + 5 ;
                    p_aBytes = ((v.purgableBlocks+v.freeBlocks) * 1000L / v.totalBlocks) + 5 ;
                    p_fBytes /= 10L ;
                    p_pBytes /= 10L ;
                    p_aBytes /= 10L ;

                    printf( "%s/%s:\n", serverName, v.volName );
                    printf( "\tTotal bytes .........%14s\n", s_tBytes );
                    printf( "\tFree  bytes .........%14s %3lu%%\n", s_fBytes, p_fBytes );
                    printf( "\tPurgable bytes ......%14s %3lu%%\n", s_pBytes, p_pBytes );
                    printf( "\tTotal available bytes%14s %3lu%% %s\n", s_aBytes, p_aBytes,
                            ((p_aBytes < 5) || (v_aBytes < 10000L) ? " <<< space is getting low <<<" : "") );

                    v_tBytes -= v_aBytes ;
                    Format_UINT32( v_tBytes, s_tBytes );
                    p_aBytes = ((v.totalBlocks-(v.purgableBlocks+v.freeBlocks)) * 1000L / v.totalBlocks) + 5 ;
                    p_aBytes /= 10L ;
                    printf( "\tTotal bytes used ....%14s %3lu%%\n", s_tBytes, p_aBytes );

                    if ( verbose )
                        printf( "\tBlock size .......... %d\n", v.blockSize );
                }
            }
        }
    }
    exit( 0 );
}
